from resources import core, Characters, load_data, math3d
from resources import obj_loader, particle_effects, physics
from resources.core import *

import random

def main():
    core.start3d([640,480])

    tex = load_data.load_textures()
    objs = load_data.load_objects(tex, False, True)

    player=Characters.Player(objs['Wizard.obj'],
                             objs['base_player.obj'],
                             [0,0,0], color=[0,1,0,1])
    player_effect=particle_effects.DirectionalGenerator(15, [0,0,0], [0,0,0],
                                                        [0,1,0,0.5],
                                                        tex['base_player.png'].image,
                                                        0.35, [0.01,0.05,0.01], 100,
                                                        0.001, [0,0,10],
                                                        particle_speed_deviation=[0.01,0.1,0.01])

    moving=[0,0]

    clock=pygame.time.Clock()
    glClearColor(1,1,1,1)
    while 1:
        clock.tick(90)
        pygame.event.pump()
        for event in pygame.event.get():
            if event.type==QUIT:
                pygame.quit()
                return

            if event.type==KEYDOWN:
                if event.key==K_UP:
                    moving[1]=-1
                if event.key==K_DOWN:
                    moving[1]=1

                if event.key==K_LEFT:
                    moving[0]=-1
                if event.key==K_RIGHT:
                    moving[0]=1

                if event.key==K_SPACE:
                    player.collider.push([0,1,0])

            if event.type==KEYUP:
                if event.key==K_UP:
                    moving[1]=0
                if event.key==K_DOWN:
                    moving[1]=0
                if event.key==K_LEFT:
                    moving[0]=0
                if event.key==K_RIGHT:
                    moving[0]=0

        player.collider.move([0.1*moving[0], 0, 0.1*moving[1]])

        player_effect.pos=list(player.collider.pos)
        player_effect.pos[1]+=2
        player_effect.update()

        core.clear_screen()

        glPushMatrix()
        player.update()
        glRotatef(25,1,0,0)
        glTranslatef(0,-20,-30)
        glTranslatef(-player.collider.pos[0],
                     -player.collider.pos[1],
                     -player.collider.pos[2])
        player.render()

        player_effect.render()

        glPopMatrix()
        pygame.display.flip()

main()
                                        
