import math3d, physics
from core import *
        
class Player(object):
    def __init__(self, obj, shot_obj, pos, hitpoints=1,
                 speed=1, attack=1, attack_type='light',
                 defenses={'light':1,
                           'darkness':1,
                           'fire':1,
                           'water':1,
                           'plant':1,
                           'earth':1,
                           'energy':1},
                 projectile_speed=1,
                 attack_speed=1,
                 attack_dur=15,
                 color=[1,1,1,1]):
        self.obj=obj
        self.shot_obj=shot_obj
        self.collider=physics.BBox(pos, self.obj.bb, 0.005)
        self.rotation=[0,0,0]

        self.color=color

        self.max_hitpoints=hitpoints
        self.hitpoints=int(self.max_hitpoints)
        self.speed=speed

        self.attack=attack
        self.attack_type=attack_type
        self.defenses=defenses
        self.projectile_speed=projectile_speed

        self.attack_speed=attack_speed
        self.cur_attack_phase=0

        self.attack_dur=attack_dur

        self.dead=False

        self.attackers=[]

    def get_attacks(self):
        a = list(self.attackers)
        self.attackers=[]
        return a

    def do_attack(self):
        self.cur_attack_phase+=1
        if self.cur_attack_phase==self.attack_speed:
            self.cur_attack_phase=0
            self.attacker.append(PlayerShot(self.shot_obj,
                                          self.pos,
                                          self.rotation,
                                          self.attack,
                                          self.attack_type,
                                          self.projectile_speed,
                                          self.attack_dur))
                              

    def update(self):
        self.collider.push([0,-0.0175,0])#gravity ;)
        self.collider.update()

        if self.collider.pos[1]-self.collider.get_height()<0:
            self.collider.pos[1]=self.collider.get_height()
            self.collider.velocity[1]=0
        if self.hitpoints<=0:
            self.dead=True

    def move(self, m):
        self.collider.push(m)

    def rotate(self, r):
        self.rotation[1]+=r[1]
        self.rotation[2]+=r[2]
        self.rotation=math3d.confine_rotation(self.rotation)

    def check_collision(self, other):
        pass

    def render(self):
        glPushMatrix()
        glColor4f(*self.color)
        glTranslatef(*self.collider.pos)
        glRotatef(self.rotation[0],1,0,0)
        glRotatef(self.rotation[1],0,1,0)
        glRotatef(self.rotation[2],0,0,1)
        self.obj.render()
        glPopMatrix()
