from core import *

def fix_image(surf):
    a=2
    ma = surf.get_width()
    while a<ma:
        a=a*2
    b=2
    mb=surf.get_width()
    while b<mb:
        b=b*2
    surf=pygame.transform.scale(surf, (a, b))
    return surf

def load_image(filename):
    surf = pygame.image.load(filename)
    surf=fix_image(surf)
    return surf, pygame.image.tostring(surf, 'RGBA', 1)
    
class Texture(object):
    def __init__(self, filename, do_load=True):
        self.filename=filename
        self.image=None
        if do_load:
            self.load_image()

    def load_image(self):
        surf, image = load_image(self.filename)
        ix, iy = surf.get_rect().size
        self.image = glGenTextures(1)
        glBindTexture(GL_TEXTURE_2D, self.image)
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
            GL_LINEAR)
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
            GL_LINEAR)
        glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, ix, iy, 0, GL_RGBA,
            GL_UNSIGNED_BYTE, image)
